.386
.model flat,stdcall
option casemap:none

include         \masm32\include\windows.inc
include         \masm32\include\kernel32.inc
include         \masm32\include\user32.inc
include         \masm32\include\masm32.inc

dat2obj         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD ; Hutch's dat2obj converter
ParseCmdLine    PROTO :DWORD

includelib      \masm32\lib\kernel32.lib
includelib      \masm32\lib\user32.lib
includelib      \masm32\lib\masm32.lib
includelib      parsecmdline.lib
includelib      dat2obj.lib

FILE_ALIGN = 4

.data
res0    db 0
res1    db 'Cursor',0
res2    db 'Bitmap',0
res3    db 'Icon',0
res4    db 'Menu',0
res5    db 'Dialog',0
res6    db 'String table',0
res7    db 'Font directory',0
res8    db 'Font',0
res9    db 'Accelerators table',0
resA    db 'RC Data (custom binary data)',0
resB    db 'Message table',0
resC    db 'Group cursor',0
resD    db 0
resE    db 'Group icon',0
resF    db 0
res10   db 'Version Information',0
res11   db 'Dialog Include',0
res12   db 0
res13   db 'Plug ',39,'n',39,' Play',0
res14   db 'VXD',0
res15   db 'Animated Cursor',0
res16   db 'Animated Icon',0
restabl dd res0,res1,res2,res3,res4,res5,res6,res7,res8
        dd res9,resA,resB,resC,resD,resE,resF,res10
        dd res11,res12,res13,res14,res15,res16   

message db 'Resource to object file converter V1.0 Beta 1',13,10
        db 'usage     : res2obj rsrcfile.res output.obj label',13,10
        db '          : res2obj rsrcfile.res -b [ output binary file ]',0
format1 db 'Resource type:%s OFFSET=%X SIZE=%X',13,10,0
format2 db 'Resource type:%s - USER DEFINED   OFFSET=%X SIZE=%X',13,10,0

nofileext       db 'Input file with no extension',0
alignvalue      dd 4
resoffset       dd 0
resheader       dd 0,000000020h,00000FFFFh,00000FFFFh,0,0,0,0
notvalidres     db 'Invalid resource file',0
nofile          db 'Error on reading file',0
bytes           db 0,0,0,0
binout          dd 0

.data?
cmdlineparam    db 512 dup(?)
msgbuffer       db 512 dup(?)
msgbuffer2      db 512 dup(?)
buffer          dd ?
buffer2         dd ?
temp            dd ?
hRes            dd ?
hBin            dd ?
fSize           dd ?
eof             dd ?
size1           dd ?
cmdline         dd ?
pObj            dd ?
flen            dd ?

.code
start:
        invoke  ParseCmdLine,ADDR cmdlineparam
        cmp     eax,3
        jae     @f
errmsg:
        invoke  StdOut,ADDR message
        jmp     finish
@@:
        mov     edx,OFFSET cmdlineparam
        mov     cmdline,edx
        cmp     eax,4
        je      @f
        mov     ecx,DWORD PTR [edx+8]
        cmp     WORD PTR [ecx],'b-'
        jne     errmsg
        mov     binout,1
@@:
        invoke  CreateFile,DWORD PTR [edx+4],GENERIC_READ,\
                0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
        cmp     eax,INVALID_HANDLE_VALUE
        jne     @f
        invoke  StdOut,ADDR nofile
        jmp     finish
@@:
        mov     hRes,eax
        invoke  GetFileSize,eax,0
        mov     fSize,eax
        invoke  GlobalAlloc,GPTR,eax
        mov     buffer,eax
        cmp     binout,1
        je      @f
        invoke  GlobalAlloc,GPTR,fSize
        mov     buffer2,eax
        mov     pObj,eax
@@:
        invoke  ReadFile,hRes,buffer,fSize,ADDR temp,0
        invoke  CloseHandle,hRes
        cmp     binout,1
        jne     nobinaryoutput
        mov     ecx,cmdline
        mov     edx,DWORD PTR [ecx+4]
@@:
        mov     al,[edx]
        cmp     al,'.'
        je      @f
        or      al,al
        jz      noext
        inc     edx
        jmp     @b
@@:
        inc     edx
        mov     DWORD PTR [edx],'nib'
nobinaryoutput:        
        mov     esi,buffer
        mov     edi,esi
        add     edi,fSize
        mov     eof,edi
        mov     ecx,8
        mov     edx,OFFSET resheader
@@:
        mov     eax,DWORD PTR [edx]
        cmp     DWORD PTR [esi],eax
        jne     invalid
        add     esi,4
        add     edx,4
        loop    @b 
        cmp     binout,1
        je      binfile
        jmp     restart
invalid:
        invoke  StdOut,ADDR notvalidres
        jmp     finish
binfile:
        mov     edx,cmdline
        invoke  CreateFile,DWORD PTR [edx+4],GENERIC_WRITE,\
                0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
        mov     hBin,eax
restart:
        mov     eax,DWORD PTR [esi+8]
        cmp     ax,0FFFFh
        je      @f
        invoke  WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,\
                eax,-1,ADDR msgbuffer2,512,0,0
        invoke  wsprintf,ADDR msgbuffer,ADDR format2,ADDR msgbuffer2,resoffset,DWORD PTR [esi]
        jmp     OK
@@:
        push    eax
        mov     eax,resoffset
        xor     edx,edx
        div     [alignvalue]
        or      edx,edx
        jz      @f
        neg     edx
        mov     ecx,resoffset
        lea     ecx,[ecx+edx+4]
        jmp     l1
@@:
        mov     ecx,resoffset
l1:
        pop     eax
        shr     eax,16
        lea     eax,[restabl+4*eax]
        invoke  wsprintf,ADDR msgbuffer,ADDR format1,DWORD PTR [eax],ecx,DWORD PTR [esi]
OK:
        invoke  StdOut,ADDR msgbuffer
        mov     eax,DWORD PTR [esi]
        add     resoffset,eax
        mov     ecx,DWORD PTR [esi+4]
        lea     edx,[esi+ecx]
        cmp     binout,1
        je      @f
        invoke  MemCopy,edx,pObj,eax
        add     pObj,eax
        jmp     nobin1
@@:
        invoke  WriteFile,hBin,edx,eax,ADDR size1,0
nobin1:
        mov     eax,DWORD PTR [esi]
        add     eax,DWORD PTR [esi+4]
        add     esi,eax
        xor     edx,edx
        mov     eax,esi
        div     [alignvalue]
        or      edx,edx
        jz      nowritefile
        neg     edx
        lea     ecx,[edx+4]
        lea     esi,[esi+ecx]
        cmp     binout,1
        je      @f
        push    ecx
        invoke  MemCopy,ADDR bytes,pObj,ecx
        pop     ecx
        add     pObj,ecx
        jmp     nowritefile
@@:        
        invoke  WriteFile,hBin,ADDR bytes,ecx,ADDR size1,0	
nowritefile:
        cmp     esi,eof
        jb      restart
        cmp     binout,1
        jne     @f
        invoke  CloseHandle,hBin
        jmp     finish        
@@:
        mov     edx,cmdline
        mov     eax,pObj
        sub     eax,buffer2
        invoke  dat2obj,buffer2,eax,DWORD PTR [edx+8],DWORD PTR [edx+12],FILE_ALIGN
        invoke  GlobalFree,buffer2
finish:
        invoke  GlobalFree,buffer
        invoke  ExitProcess,0
noext:
        invoke  StdOut,ADDR nofileext
        jmp     finish
END start