; data to object file converter by Hutch

; 

    .486                      ; force 32 bit code
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\macros\macros.asm

    .code

; 

align 4

dat2obj proc pdata:DWORD,flen:DWORD,poutput:DWORD,pname:DWORD,alind:DWORD

comment * -----------------------------------------------------------------

        pdata  = address of data to convert to obj
        flen    = length of input data
        poutput = address of output file name
        pname   = address of public label name
        alind   = module alignment

        ----------------------------------------------------------------- *

    LOCAL hout          :DWORD              ; output file handle
    LOCAL wcnt          :DWORD
    LOCAL pftr          :DWORD
    LOCAL aflag         :DWORD              ; alignment flag
    LOCAL ifh           :IMAGE_FILE_HEADER
    LOCAL ish           :IMAGE_SECTION_HEADER
    LOCAL ist           :IMAGE_SYMBOL

    switch alind
      case 1
        mov aflag, IMAGE_SCN_ALIGN_1BYTES
      case 2
        mov aflag, IMAGE_SCN_ALIGN_2BYTES
      case 4
        mov aflag, IMAGE_SCN_ALIGN_4BYTES
      case 8
        mov aflag, IMAGE_SCN_ALIGN_8BYTES
      case 16
        mov aflag, IMAGE_SCN_ALIGN_16BYTES
      case 32
        mov aflag, IMAGE_SCN_ALIGN_32BYTES
      case 64
        mov aflag, IMAGE_SCN_ALIGN_64BYTES
      case 128
        mov aflag, IMAGE_SCN_ALIGN_128BYTES
      case 256
        mov aflag, IMAGE_SCN_ALIGN_256BYTES
      case 512
        mov aflag, IMAGE_SCN_ALIGN_512BYTES
      case 1024
        mov aflag, IMAGE_SCN_ALIGN_1024BYTES
      case 2048
        mov aflag, IMAGE_SCN_ALIGN_2048BYTES
      case 4096
        mov aflag, IMAGE_SCN_ALIGN_4096BYTES
      case 8192
        mov aflag, IMAGE_SCN_ALIGN_8192BYTES
    endsw

  ; ***********************************************************************

    mov hout, fcreate(poutput)

  ; ----------------------------------------------
  ; calculate the start offset of the symbol table
  ; ----------------------------------------------
    mov edx, SIZEOF IMAGE_FILE_HEADER
    add edx, SIZEOF IMAGE_SECTION_HEADER
    add edx, flen

  ; -----------------
  ; IMAGE_FILE_HEADER
  ; -----------------
    mov ifh.Machine,                IMAGE_FILE_MACHINE_I386         ; dw
    mov ifh.NumberOfSections,       1                               ; dw
    mov ifh.TimeDateStamp,          0                               ; dd
    mov ifh.PointerToSymbolTable,   edx                             ; dd
    mov ifh.NumberOfSymbols,        1                               ; dd
    mov ifh.SizeOfOptionalHeader,   0                               ; dw
    mov ifh.Characteristics,        IMAGE_FILE_RELOCS_STRIPPED or \
                                    IMAGE_FILE_LINE_NUMS_STRIPPED   ; dw
  ; --------------------
  ; IMAGE_SECTION_HEADER
  ; --------------------
    lea eax, ish.Name1
    mov DWORD PTR [eax], "tad."     ; write ".data" to Name1 member
    mov DWORD PTR [eax+4], "a"

    mov ish.Misc.PhysicalAddress,   0           ; dd
    mov ish.VirtualAddress,         0           ; dd
    m2m ish.SizeOfRawData,          flen        ; dd

    mov edx, SIZEOF IMAGE_FILE_HEADER
    add edx, SIZEOF IMAGE_SECTION_HEADER
    mov ish.PointerToRawData,       edx         ; dd

    mov ish.PointerToRelocations,   0           ; dd
    mov ish.PointerToLinenumbers,   0           ; dd
    mov ish.NumberOfRelocations,    0           ; dw
    mov ish.NumberOfLinenumbers,    0           ; dw

    mov eax, IMAGE_SCN_CNT_INITIALIZED_DATA or IMAGE_SCN_MEM_READ or IMAGE_SCN_MEM_WRITE
    or eax, aflag
    mov ish.Characteristics, eax                ; dd

  ; -----------------
  ; COFF SYMBOL TABLE
  ; -----------------
    lea eax, ist.N.LongName
    mov DWORD PTR [eax], 0                      ; zero fill 1st 4 bytes
    mov DWORD PTR [eax+4], 4                    ; OFFSET is 4th byte into the string table

    mov ist.Value, 0
    mov ist.SectionNumber, 1
    mov ist.Type1, 0
    mov ist.StorageClass, IMAGE_SYM_CLASS_EXTERNAL
    mov ist.NumberOfAuxSymbols, 0

  ; --------------------
  ; write result to file
  ; --------------------
    mov wcnt, fwrite(hout,ADDR ifh,SIZEOF IMAGE_FILE_HEADER)
    mov wcnt, fwrite(hout,ADDR ish,SIZEOF IMAGE_SECTION_HEADER)
    mov wcnt, fwrite(hout,pdata,flen)           ; write the file data
    mov wcnt, fwrite(hout,ADDR ist,SIZEOF IMAGE_SYMBOL)

  ; ------------
  ; string table
  ; ------------
    mov wcnt, 64
    mov wcnt, fwrite(hout,ADDR wcnt,4)          ; write the table length to 1st DWORD

    mov edx, len(pname)
    mov wcnt, fwrite(hout,pname,edx)            ; write the data label name after it.

    mov edx, len(pname)                         ; length of name
    add edx, 4                                  ; add 4 for 1st DWORD
    mov wcnt, 65
    sub wcnt, edx

    .data
      filled db 128 dup (0)
    .code

    mov wcnt, fwrite(hout,ADDR filled,wcnt)

    fclose hout

    mov eax, wcnt

    ret

dat2obj endp

; 

end
